/* Dave Pallot */
/* pallot@iinet.net.au */
/* Copyright 2000 */

#ifndef INETADDRESS_H
#define INETADDRESS_H

#include <string>
#include <winsock.h>

class InetAddress
{
public:
    InetAddress() {}
    virtual ~InetAddress() {}

public:
	/* Returns in Host Byte Order */
	unsigned long getULongIP() const
	{
		return ::ntohl(m_address.sin_addr.S_un.S_addr);
	}

	/* Returns in Host Byte Order */
	unsigned short getPort() const 
	{
		return ::ntohs(m_address.sin_port);
	}

	std::string getStrIP() const
	{
		return std::string(::inet_ntoa(m_address.sin_addr));
	}

private:
	struct sockaddr_in m_address;

	friend class Socket;
};

#endif //INETADDRESS_H