/* Dave Pallot */
/* pallot@iinet.net.au */
/* Copyright 2000 */

#ifndef THREAD_H
#define THREAD_H

#pragma warning(disable : 4355)

#include <windows.h>
#include "Semaphore.h"


class Runnable;

class Thread
{
public:
	Thread(Runnable* runnable);
	virtual ~Thread();    

public:
	bool start();
	void join();

	inline bool isRunning() { return m_running; }

private:
	void stop();

private:
	HANDLE m_threadHandle;
	bool m_running;
	bool m_waiting;

	Runnable* m_run;
	Semaphore m_semaphore;
	
	friend DWORD WINAPI ThreadProc(LPVOID param);
};


class Runnable : public Thread
{
protected:
	Runnable() : Thread(this)
	{}

	virtual ~Runnable() {}

public:
	virtual void runThis() = 0;
};

#endif //THREAD_H